Today's changes.
diff --git a/bin/9l b/bin/9l
index e510e4d..a7924e7 100755
--- a/bin/9l
+++ b/bin/9l
@@ -3,12 +3,24 @@
 extralibs=-lm
 tag="${SYSNAME:-`uname`}-${OBJTYPE:-`uname -m`}"
 case "$tag" in
-*FreeBSD*)	ld=gcc ;;
+*OpenBSD*)	ld=gcc
+		extralibs="$extralibs -lpthread"
+		;;
 *BSD*)		ld=gcc ;;
 *Linux*)	ld=gcc ;;
 *Darwin*)	ld=gcc ;;
 *SunOS*)	ld="${CC9:-cc} -g"
 		extralibs="$extralibs -lrt -lpthread -lsocket -lnsl"
+		# Record paths to shared libraries to avoid needing LD_LIBRARY_PATH 
+		for i in "$@"
+		do
+			case "$i" in
+			-L*)
+				s=`echo $i | sed 's/-L/-R/'`
+				extralibs="$extralibs $s"
+				;;
+			esac
+		done
 		;;
 *)
 	echo do not know how to link on "$tag" 1>&2
diff --git a/bin/awd b/bin/awd
new file mode 100755
index 0000000..4b1ab78
--- /dev/null
+++ b/bin/awd
@@ -0,0 +1,3 @@
+#!/bin/sh
+
+label `pwd`
diff --git a/bin/g b/bin/g
new file mode 100755
index 0000000..c9e8b92
--- /dev/null
+++ b/bin/g
@@ -0,0 +1,19 @@
+#!/usr/local/plan9/bin/rc
+
+flags=()
+while(! ~ $#* 1 && ~ $1 -*){
+	flags=($flags $1)
+	shift
+}
+
+switch($#*){
+case 0
+	echo 'usage: g [flags] pattern [files]' >[1=2]
+	exit 1
+case 1
+	9grep -n $flags -- $1 *.[Cbchm] *.cc *.py *.tex *.ms *.java /dev/null \
+	  |[2] {9grep -v '^(grep: can''t open \*|grep: \*\.)' >[1=2]; status=0}
+case *
+	9grep -n $flags -- $* /dev/null
+}
+
diff --git a/bin/ps b/bin/ps
index 54678eb..d7e0767 100755
--- a/bin/ps
+++ b/bin/ps
@@ -15,6 +15,7 @@
 	state["I"] = "Idle";
 	state["J"] = "Jail";
 	state["R"] = "Ready";
+	state["O"] = "Running";
 	state["S"] = "Sleep";
 	state["T"] = "Stopped";
 	state["Z"] = "Zombie";
@@ -65,8 +66,16 @@
 }
 !
 
-/bin/ps -axww -o 'user,pid,start,time,vsz,stat,command' | sed 1d |
-	awk -f /tmp/awk.xxx$$ | sort -n +1
+case "${SYSNAME:-`uname`}" in 
+SunOS)
+	/bin/ps -aA -o 'user,pid,stime,time,vsz,s,args' | sed 1d |
+		nawk -f /tmp/awk.xxx$$ | sort -n +1
+	;;
+*)
+	/bin/ps -axww -o 'user,pid,start,time,vsz,stat,command' | sed 1d |
+		awk -f /tmp/awk.xxx$$ | sort -n +1
+	;;
+esac
 
 rm -f /tmp/awk.xxx$$
 
diff --git a/bin/web b/bin/web
index a597f2d..7ca1c7d 100755
--- a/bin/web
+++ b/bin/web
@@ -10,6 +10,7 @@
 		;;
 	*firebird*)
 		$BROWSER -remote 'openURL('$i', new-window)'
+		;;
 	*firefox*)
 		$BROWSER -remote 'openURL('$i', new-window)'
 		;;